Accessibility in Angular Dropdown List

The DropDownList component is designed with WAI-ARIA specifications, applying the necessary roles, states, and properties to support keyboard interaction. This ensures that the component is fully accessible to users who rely on assistive technologies (AT) or keyboard navigation.

The DropDownList component adheres to accessibility guidelines and standards, including ADA, Section 508, WCAG 2.2 standards, and WAI-ARIA roles that are commonly used to evaluate accessibility.

The accessibility compliance for the DropDownList component is outlined below.

Accessibility Criteria Compatibility
WCAG 2.2 Support Yes
Section 508 Support Yes
Screen Reader Support Yes
Right-To-Left Support Yes
Color Contrast Yes
Mobile Device Support Yes
Keyboard Navigation Support Yes
Accessibility Checker Validation Yes
Axe-core Accessibility Validation Yes
Yes - All features of the component meet the requirement.
Intermediate - Some features of the component do not meet the requirement.
No - The component does not meet the requirement.

WAI-ARIA attributes

The component’s design implements the listbox role for the main wrapper and the option role for each item in the popup list. The following ARIA attributes provide detailed information about the DropDownList’s state for assistive technologies.

Properties Functionalities
aria-haspopup Announces to assistive technologies that the component’s input element will trigger a popup list.
aria-expanded Communicates the current state (expanded or collapsed) of the popup list.
aria-selected Identifies the currently selected item within the list, ensuring the user knows their choice.
aria-readonly Specifies that the DropDownList is in a read-only state, preventing user interaction.
aria-disabled Informs assistive technologies that the DropDownList is disabled and not interactive.
aria-activedescendent Holds the ID of the currently focused list item, allowing assistive technologies to track keyboard focus as the user navigates the popup.
aria-owns Programmatically links the input element to the popup list, establishing a parent-child relationship for screen readers.

Keyboard Interaction

You can use the following key shortcuts to interact with the DropDownList component.

Keyboard shortcuts Actions
Down Arrow If no item is selected, selects the first item in the DropDownList. Otherwise, moves focus to the next item.
Up Arrow Moves focus to the previous item.
Page Down When the popup is open, scrolls down one page and selects the first item in the visible view.
Page Up When the popup is open, scrolls up one page and selects the first item in the visible view.
Enter Toggles the popup list. If the popup is open, it selects the focused item and closes the popup.
Tab If the popup is closed, moves focus to the next focusable element. If the popup is open, it closes the popup, and focus remains on the component.
Shift + Tab If the popup is closed, moves focus to the previous focusable element. If the popup is open, it closes the popup, and focus remains on the component.
Alt + Down Arrow Opens the popup list.
Alt + Up Arrow Closes the popup list.
Escape Closes the popup list if it is open, retaining the currently selected item.
Home Selects the first item in the list.
End Selects the last item in the list.
A-Z or 0-9 Jumps to the next list item that starts with the typed character.

In the following sample, alt+t keys are used to focus the DropDownList component.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule, ReactiveFormsModule } from '@angular/forms'
import { DropDownListModule } from '@syncfusion/ej2-angular-dropdowns'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'



import { Component, HostListener, ViewChild } from '@angular/core';
import { DropDownListComponent } from '@syncfusion/ej2-angular-dropdowns';

@Component({
imports: [
        FormsModule, ReactiveFormsModule, DropDownListModule, ButtonModule
    ],


standalone: true,
    selector: 'app-root',
    // specifies the template string for the DropDownList component with change event
    template: `<ejs-dropdownlist id='ddlelement' #samples [dataSource]='data' [placeholder]='text' [popupHeight]='height'></ejs-dropdownlist>`
})
export class AppComponent {
    @ViewChild('samples')
    public sports?: DropDownListComponent;
    constructor() {
    }
    // defined the array of data
    public data: string[] = ['Badminton', 'Basketball', 'Cricket', 'FootBall', 'Golf', 'Hockey', 'Rugby', 'Snooker', 'Tennis'];
    // set placeholder to DropDownList input element
    public text: string = "Select a game";
    // set the popup list height
    public height: string = '200px';
    @HostListener('document:keyup', ['$event'])
    handleKeyboardEvent(event: KeyboardEvent) {
        if (event.altKey && event.keyCode === 84 /* t */) {
            // press alt+t to focus the control.
            this.sports!.focusIn();
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Ensuring accessibility

The DropDownList component’s accessibility levels are ensured through an accessibility-checker and axe-core software tools during automated testing.

The accessibility compliance of the DropDownList component is shown in the following sample. Open the sample in a new window to evaluate the accessibility of the DropDownList component with accessibility tools.

See also

Accessibility in Vue Dropdown List

21 Aug 202611 minutes to read

The DropDownList component has been designed, keeping in mind the WAI-ARIA specifications, and applies the WAI-ARIA roles, states, and properties along with keyboard support. This component is characterized by complete keyboard interaction support and ARIA accessibility support that makes it easy for people who use assistive technologies (AT) or those who completely rely on keyboard navigation.

The DropDownList component followed the accessibility guidelines and standards, including ADA, Section 508, WCAG 2.2 standards, and WCAG roles that are commonly used to evaluate accessibility.

The accessibility compliance for the DropDownList component is outlined below.

Accessibility Criteria Compatibility
WCAG 2.2 Support Yes
Section 508 Support Yes
Screen Reader Support Yes
Right-To-Left Support Yes
Color Contrast Yes
Mobile Device Support Yes
Keyboard Navigation Support Yes
Accessibility Checker Validation Yes
Axe-core Accessibility Validation Yes
Yes - All features of the component meet the requirement.
Intermediate - Some features of the component do not meet the requirement.
No - The component does not meet the requirement.

WAI-ARIA attributes

The DropDownList component uses the Listbox role, and each list item has an option role. The following ARIA attributes denote the DropDownList state.

Properties Functionalities
aria-haspopup Indicates whether the DropDownList input element has a popup list or not.
aria-expanded Indicates whether the popup list has expanded or not.
aria-selected Indicates the selected option.
aria-readonly Indicates the readonly state of the DropDownList element.
aria-disabled Indicates whether the DropDownList component is in a disabled state or not.
aria-activedescendent This attribute holds the ID of the active list item to focus its descendant child element.
aria-owns This attribute contains the ID of the popup list to indicate popup as a child element.

Keyboard interaction

You can use the following key shortcuts to access the DropDownList without interruptions.

Keyboard shortcuts Actions
Arrow Down Selects the first item in the DropDownList when no item selected. Otherwise, selects the item next to the currently selected item.
Arrow Up Selects the item previous to the currently selected one.
Page Down Scrolls down to the next page and selects the first item when popup list opens.
Page Up Scrolls up to the previous page and selects the first item when popup list opens.
Enter Selects the focused item, and when it is in an open state the popup list closes. Otherwise, toggles the popup list.
Tab Focuses on the next TabIndex element on the page when the popup is closed. Otherwise, closes the popup list and remains the focus of the component.
Shift + tab Focuses on the previous TabIndex element on the page when the popup is closed. Otherwise, closes the popup list and remains the focus of the component.
Alt + Down Opens the popup list.
Alt + Up Closes the popup list.
Esc(Escape) Closes the popup list when it is in an open state and the currently selected item remains the same.
Home Selects the first item.
End Selects the last item.

In the below sample, focus the DropDownList component using alt+t keys.

<template>
  <div id="app">
    <div id='container' style="margin:50px auto 0; width:250px;">
      <br>
      <ejs-dropdownlist id='dropdownlist' ref="DropdownInstance" placeholder='Select a game' popupHeight='200px'
        :fields='fields' :dataSource='dataSource'></ejs-dropdownlist>
    </div>
  </div>
</template>
<script setup>
import { onMounted, ref } from "vue";
import { DropDownListComponent as EjsDropdownlist } from "@syncfusion/ej2-vue-dropdowns";

const DropdownInstance = ref(null);
onMounted(() => {
  let dropdownObj = DropdownInstance.value;
  document.onkeyup = function (e) {
    if (e.altKey && e.keyCode === 84) {
      // press alt+t to focus the control.
      dropdownObj.$el.focus();
    }
  }
});

const dataSource = [
  { Id: 'Game1', Game: 'Badminton' },
  { Id: 'Game2', Game: 'Basketball' },
  { Id: 'Game3', Game: 'Cricket' },
  { Id: 'Game4', Game: 'Football' },
  { Id: 'Game5', Game: 'Golf' },
  { Id: 'Game6', Game: 'Hockey' },
  { Id: 'Game7', Game: 'Rugby' },
  { Id: 'Game8', Game: 'Snooker' },
  { Id: 'Game9', Game: 'Tennis' }
]
const fields = { text: 'Game', value: 'Id' }


</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
</style>
<template>
  <div id="app">
    <div id='container' style="margin:50px auto 0; width:250px;">
      <br>
      <ejs-dropdownlist id='dropdownlist' ref="DropdownInstance" placeholder='Select a game' popupHeight='200px'
        :fields='fields' :dataSource='dataSource'></ejs-dropdownlist>
    </div>
  </div>
</template>
<script>
import { DropDownListComponent } from "@syncfusion/ej2-vue-dropdowns";

export default {
  name: "App",
  components: {
    "ejs-dropdownlist": DropDownListComponent
  },
  mounted() {
    let dropdownObj = this.$refs.DropdownInstance;
    document.onkeyup = function (e) {
      if (e.altKey && e.keyCode === 84) {
        // press alt+t to focus the control.
        dropdownObj.$el.focus();
      }
    }
  },
  data() {
    return {
      dataSource: [
        { Id: 'Game1', Game: 'Badminton' },
        { Id: 'Game2', Game: 'Basketball' },
        { Id: 'Game3', Game: 'Cricket' },
        { Id: 'Game4', Game: 'Football' },
        { Id: 'Game5', Game: 'Golf' },
        { Id: 'Game6', Game: 'Hockey' },
        { Id: 'Game7', Game: 'Rugby' },
        { Id: 'Game8', Game: 'Snooker' },
        { Id: 'Game9', Game: 'Tennis' }
      ],
      fields: { text: 'Game', value: 'Id' }
    }
  }
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
</style>

Ensuring accessibility

The DropDownList component’s accessibility levels are ensured through an accessibility-checker and axe-core software tools during automated testing.

The accessibility compliance of the DropDownList component is shown in the following sample. Open the sample in a new window to evaluate the accessibility of the DropDownList component with accessibility tools.

See also

Accessibility in React Dropdown List

9 Aug 202618 minutes to read

The DropDownList component is built according to WAI-ARIA specifications, incorporating WAI-ARIA roles, states, properties, and comprehensive keyboard support. The component provides complete keyboard navigation and ARIA accessibility, enabling users of assistive technologies and keyboard-only users to interact effectively.

The DropDownList component adheres to established accessibility standards and guidelines, including ADA, Section 508, WCAG 2.2, and WAI-ARIA roles.

The accessibility compliance for the DropDownList component is outlined below.

Accessibility Criteria Compatibility
WCAG 2.2 Support Yes
Section 508 Support Yes
Screen Reader Support Yes
Right-To-Left Support Yes
Color Contrast Yes
Mobile Device Support Yes
Keyboard Navigation Support Yes
Accessibility Checker Validation Yes
Axe-core Accessibility Validation Yes
Yes - All features of the component meet the requirement.
Intermediate - Some features of the component do not meet the requirement.
No - The component does not meet the requirement.

WAI-ARIA attributes

The DropDownList component followed the WAI-ARIA patterns to meet the accessibility. The following ARIA attributes are used in the DropDownList component:

Properties Functionalities
aria-haspopup Indicates whether the DropDownList input element has a popup list or not.
aria-expanded Indicates whether the popup list has expanded or not.
aria-selected Indicates the selected option.
aria-readonly Indicates the readonly state of the DropDownList element.
aria-disabled Indicates whether the DropDownList component is in a disabled state or not.
aria-activedescendent This attribute holds the ID of the active list item to focus its descendant child element.
aria-owns This attribute contains the ID of the popup list to indicate popup as a child element.

Keyboard interaction

You can use the following key shortcuts to access the DropDownList without interruptions.

Keyboard shortcuts Actions
Arrow Down Selects the first item in the DropDownList when no item selected. Otherwise, selects the item next to the currently selected item.
Arrow Up Selects the item previous to the currently selected one.
Page Down Scrolls down to the next page and selects the first item when popup list opens.
Page Up Scrolls up to the previous page and selects the first item when popup list opens.
Enter Selects the focused item, and when it is in an open state the popup list closes. Otherwise, toggles the popup list.
Tab Focuses on the next TabIndex element on the page when the popup is closed. Otherwise, closes the popup list and remains the focus of the component.
Shift + tab Focuses on the previous TabIndex element on the page when the popup is closed. Otherwise, closes the popup list and remains the focus of the component.
Alt + Down Opens the popup list.
Alt + Up Closes the popup list.
Esc(Escape) Closes the popup list when it is in an open state and the currently selected item remains the same.
Home Selects the first item.
End Selects the last item.

In the below sample, alt+t keys are used to focus the DropDownList component.

[Class-component]

import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
export default class App extends React.Component {
    // defined the array of data
    gameList = [
        { Id: 'Game1', Game: 'Badminton' },
        { Id: 'Game2', Game: 'Basketball' },
        { Id: 'Game3', Game: 'Cricket' },
        { Id: 'Game4', Game: 'Football' },
        { Id: 'Game5', Game: 'Golf' },
        { Id: 'Game6', Game: 'Hockey' },
        { Id: 'Game7', Game: 'Rugby' },
        { Id: 'Game8', Game: 'Snooker' },
        { Id: 'Game9', Game: 'Tennis' }
    ];
    // maps the appropriate column to fields property
    fields = { text: 'Game', value: 'Id' };
    // instance of DropDownList component
    dropDownListObj;
    componentDidMount() {
        const proxy = this;
        document.onkeyup = (e) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press alt+t to focus the control.
                proxy.dropDownListObj.inputElement.focus();
            }
        };
    }
    render() {
        return (
        // specifies the tag for render the DropDownList component
        <DropDownListComponent id="ddlelement" ref={(scope) => { this.dropDownListObj = scope; }} popupHeight='200px' fields={this.fields} dataSource={this.gameList} placeholder="Select a game"/>);
    }
}
ReactDOM.render(<App />, document.getElementById('sample'));
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';
import * as ReactDOM from 'react-dom';

export default class App extends React.Component<{}, {}> {
    // defined the array of data
    private gameList: { [key: string]: Object }[] = [
        { Id: 'Game1', Game: 'Badminton' },
        { Id: 'Game2', Game: 'Basketball' },
        { Id: 'Game3', Game: 'Cricket' },
        { Id: 'Game4', Game: 'Football' },
        { Id: 'Game5', Game: 'Golf' },
        { Id: 'Game6', Game: 'Hockey' },
        { Id: 'Game7', Game: 'Rugby' },
        { Id: 'Game8', Game: 'Snooker' },
        { Id: 'Game9', Game: 'Tennis' }
    ];

    // maps the appropriate column to fields property
    private fields: object = { text: 'Game', value: 'Id' };

    // instance of DropDownList component
    private dropDownListObj: any;

    public componentDidMount() {
        const proxy = this;
        document.onkeyup = (e) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press alt+t to focus the control.
                proxy.dropDownListObj.inputElement.focus();
            }
        };
    }

    public render() {
        return (
            // specifies the tag for render the DropDownList component
            <DropDownListComponent id="ddlelement" ref={(scope) => { this.dropDownListObj = scope; }} popupHeight='200px' fields={this.fields} dataSource={this.gameList} placeholder="Select a game" />
        );
    }
}
ReactDOM.render(<App />, document.getElementById('sample'));

[Functional-component]

import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
function App() {
    // defined the array of data
    const gameList = [
        { Id: 'Game1', Game: 'Badminton' },
        { Id: 'Game2', Game: 'Basketball' },
        { Id: 'Game3', Game: 'Cricket' },
        { Id: 'Game4', Game: 'Football' },
        { Id: 'Game5', Game: 'Golf' },
        { Id: 'Game6', Game: 'Hockey' },
        { Id: 'Game7', Game: 'Rugby' },
        { Id: 'Game8', Game: 'Snooker' },
        { Id: 'Game9', Game: 'Tennis' }
    ];
    // maps the appropriate column to fields property
    const fields = { text: 'Game', value: 'Id' };
    // instance of DropDownList component
    let dropDownListObj;
    React.useEffect(() => {
        document.onkeyup = (e) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press alt+t to focus the control.
                dropDownListObj.inputElement.focus();
            }
        };
    }, []);
    return (
    // specifies the tag for render the DropDownList component
    <DropDownListComponent id="ddlelement" ref={(scope) => { dropDownListObj = scope; }} popupHeight='200px' fields={fields} dataSource={gameList} placeholder="Select a game"/>);
}
ReactDOM.render(<App />, document.getElementById('sample'));
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';
import * as ReactDOM from 'react-dom';

function App() {
    // defined the array of data
    const gameList: { [key: string]: Object }[] = [
        { Id: 'Game1', Game: 'Badminton' },
        { Id: 'Game2', Game: 'Basketball' },
        { Id: 'Game3', Game: 'Cricket' },
        { Id: 'Game4', Game: 'Football' },
        { Id: 'Game5', Game: 'Golf' },
        { Id: 'Game6', Game: 'Hockey' },
        { Id: 'Game7', Game: 'Rugby' },
        { Id: 'Game8', Game: 'Snooker' },
        { Id: 'Game9', Game: 'Tennis' }
    ];

    // maps the appropriate column to fields property
    const fields: object = { text: 'Game', value: 'Id' };

    // instance of DropDownList component
    let dropDownListObj: any;
    React.useEffect(() => {
        document.onkeyup = (e) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press alt+t to focus the control.
                dropDownListObj.inputElement.focus();
            }
        };
    }, []);
    return (
    // specifies the tag for render the DropDownList component
        <DropDownListComponent id="ddlelement" ref={(scope) => { dropDownListObj = scope; }} popupHeight='200px' fields={fields} dataSource={gameList} placeholder="Select a game" />
    );
}
ReactDOM.render(<App />, document.getElementById('sample'));

Ensuring accessibility

The DropDownList component’s accessibility levels are ensured through an accessibility-checker and axe-core software tools during automated testing.

The accessibility compliance of the DropDownList component is shown in the following sample. Open the sample in a new window to evaluate the accessibility of the DropDownList component with accessibility tools.

See also